Bug 1004963 - Review Request: openstack-heat-templates - Heat example templates and DIB elements
Review Request: openstack-heat-templates - Heat example templates and DIB ele...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Zane Bitter
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-05 17:29 EDT by Steven Dake
Modified: 2016-04-26 12:14 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-01-15 11:58:10 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zbitter: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Comment 1 Jamie Nguyen 2013-09-06 05:47:45 EDT
Issues:
=======

1) Please add a URL tag.

2) Please use the GitHub Source URL guidelines:
https://fedoraproject.org/wiki/Packaging:SourceURL#Github

3) This is a pre-release package (as upstream have not made any releases yet), so please use the snapshot package guidelines and pre-release package naming guidelines:
https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Snapshot_packages
https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Pre-Release_packages

4) There is no version indicated upstream, and I can't find any indication that '0.0.1' will be the version they will start with. Start versioning from '0' instead, so something like openstack-heat-templates-0-0.1.20130813git. Upstream might start from version '0.0.0', in which case '0.0.1' will be newer than upstream.

5) The files are not purely documentation files and include shell scripts. %{_datadir}/%{name} is probably a better location.

6) There are no %build or %install sections. These aren't compulsory, but it's common practice to include them anyway even if you're not running any commands inside them. It'll also silence the rpmlint warnings. This is not a MUST though, so I won't block the review on this.

7) I'd say openshift-origin/ directory should be put into a separate subpackage possibly called openshift-origin-templates.
Comment 2 Steven Dake 2013-12-12 19:33:51 EST
Jamie,

Thanks for the great constructive review comments.  I have made the suggested improvements, minus putting the openshift-origin and openshift-enterprise templates in a separate package.  I don't think that makes sense for the openstack-heat-templates repo, since we will be adding more components over time and I'd prefer not to have a ton of packages for each example template.

Spec URL: https://raw.github.com/sdake/fedora-reviews/master/openstack-heat-templates/openstack-heat-templates.spec
SRPM URL: https://github.com/sdake/fedora-reviews/blob/master/openstack-heat-templates/openstack-heat-templates-0-0.1.20131212git.fc19.src.rpm?raw=true

Description: Heat example templates and DIB elements
Fedora Account System Username:
sdake
Comment 3 Zane Bitter 2014-01-06 14:04:04 EST
1) The files hot/servers_in_new_neutron_net.yaml and hot/servers_in_existing_neutron_net.yaml have the execute bit erroneously set.

2) The cfn-json2yaml script uses the heat.common Python package, but the openstack-heat package is not Required.

3) The fetch-cloudformation-examples tool will download files to /cfn when installed in /usr/bin. This tool probably should not be packaged at all, or it should be packaged in its original location in the /usr/share hierarchy, rather than in /usr/bin.

4) The heat-jeos.sh tool uses oz-install, qemu-img and glance, but the oz, quemu-img and openstack-glance packages are not Required. It also uses the /var/lib/libvirt/images directory, but the libvirt-daemon package is not Required.

5) Should this Obsolete/Provide heat-jeos? (Related question, should heat-jeos.sh be renamed to just heat-jeos?)
Comment 4 Steven Dake 2014-01-06 18:30:06 EST
Zane,

Thanks for the helpful review comments.  I don't think we should bother with renaming heat-jeos.sh, unless upstream chooses to do that.  Ideally packages should ship pristine upstream as much as possible.

I integrated the rest of your comments:

Spec URL: https://raw.github.com/sdake/fedora-reviews/master/openstack-heat-templates/openstack-heat-templates.spec
SRPM URL: https://github.com/sdake/fedora-reviews/blob/master/openstack-heat-templates/openstack-heat-templates-0-0.1.20140106git.fc19.src.rpm?raw=true

Descritpion: Heat example templates and DIB elements

Fedora Account System Username: sdake
Comment 5 Zane Bitter 2014-01-06 19:09:20 EST
Looks good but I am not sure about "Provides: heat-jeos <= 9-1". Normally Provides specifies a single version, not a range. Also, Provides implies compatibility, which this is not giving (since the binary name changes from "heat-jeos" to "heat-jeos.sh").

The packaging guidelines state "If a package supersedes/replaces an existing package without being a compatible enough replacement as defined in above, use only the Obsoletes from above." So it sounds like s/Provides/Obsoletes/ does what we want here. (From discussion on IRC, it does trigger an rpmlint warning, but it's only a warning.)
Comment 6 Steven Dake 2014-01-06 19:11:23 EST
Zane,

Makes sense - I updated the package below:

Spec URL: https://raw.github.com/sdake/fedora-reviews/master/openstack-heat-templates/openstack-heat-templates.spec
SRPM URL: https://github.com/sdake/fedora-reviews/blob/master/openstack-heat-templates/openstack-heat-templates-0-0.1.20140106git.fc19.src.rpm?raw=true

Descritpion: Heat example templates and DIB elements

Fedora Account System Username: sdake
Comment 7 Zane Bitter 2014-01-06 20:08:45 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/zbitter/work/2014/January/heat-templates-package-
     review/review-openstack-heat-templates/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: openstack-heat-templates-0-0.1.20140106git.fc21.noarch.rpm
openstack-heat-templates.noarch: E: explicit-lib-dependency libvirt-daemon
openstack-heat-templates.noarch: W: obsolete-not-provided heat-jeos
openstack-heat-templates.noarch: W: no-manual-page-for-binary heat-jeos.sh
openstack-heat-templates.noarch: W: no-manual-page-for-binary cfn-json2yaml
1 packages and 0 specfiles checked; 1 errors, 3 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint openstack-heat-templates
openstack-heat-templates.noarch: E: explicit-lib-dependency libvirt-daemon
openstack-heat-templates.noarch: W: obsolete-not-provided heat-jeos
openstack-heat-templates.noarch: W: no-manual-page-for-binary heat-jeos.sh
openstack-heat-templates.noarch: W: no-manual-page-for-binary cfn-json2yaml
1 packages and 0 specfiles checked; 1 errors, 3 warnings.
# echo 'rpmlint-done:'


Requires
--------
openstack-heat-templates (rpmlib, GLIBC filtered):
    /bin/bash
    /usr/bin/env
    diskimage-builder
    libvirt-daemon
    openstack-glance
    openstack-heat-common
    oz
    qemu-img


Provides
--------
openstack-heat-templates:
    openstack-heat-templates


Source checksums
----------------
https://github.com/openstack/heat-templates/archive/3754320f2bd1910f0e2470fdfdbca5f4113a46c4/heat-templates-3754320f2bd1910f0e2470fdfdbca5f4113a46c4.tar.gz :
  CHECKSUM(SHA256) this package     : f9a84cb67d2f10c238625418b311def2486d383c173098e1779298843db9c5c5
  CHECKSUM(SHA256) upstream package : f9a84cb67d2f10c238625418b311def2486d383c173098e1779298843db9c5c5


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-i386
Command line :/usr/bin/fedora-review -n openstack-heat-templates --mock-options=--clean -m fedora-rawhide-i386
Comment 8 Steven Dake 2014-01-07 07:50:15 EST
New Package SCM Request
=======================
Package Name: openstack-heat-templates
Short Description: OpenStack Heat example templates and DIB files
Owners: sdake
Branches: 
InitialCC: sdake, jpeeler
Comment 9 Gwyn Ciesla 2014-01-07 08:04:15 EST
Git done (by process-git-requests).
Comment 10 Jeff Peeler 2014-01-14 20:24:51 EST
Package Change Request
======================
Package Name: openstack-heat-templates
New Branches: fc20 el6
Owners: sdake, jpeeler
Comment 11 Jeff Peeler 2014-01-14 20:26:22 EST
Package Change Request
======================
Package Name: openstack-heat-templates
New Branches: f20 el6
Owners: sdake, jpeeler
Comment 12 Gwyn Ciesla 2014-01-15 07:46:26 EST
Git done (by process-git-requests).
Comment 13 Fedora Update System 2014-01-15 16:54:03 EST
openstack-heat-templates-0-0.1.20140106git.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/openstack-heat-templates-0-0.1.20140106git.el6
Comment 14 Fedora Update System 2014-01-15 17:18:29 EST
openstack-heat-templates-0-0.1.20140106git.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/openstack-heat-templates-0-0.1.20140106git.fc20

Note You need to log in before you can comment on or make changes to this bug.